	GET	registers.s
	GET	swis.s

	AREA	|____print_getprintername|, CODE, READONLY
	EXPORT	print_getprintername
print_getprintername

	STMFD	r13!,{r4-r7,lr}
	SWI	XPDriver_Info
	MOVVS	r0,#0
	MOVVC	r0,r4
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	AREA	|____print_getfeatures|, CODE, READONLY
	EXPORT	print_getfeatures
print_getfeatures

	STMFD	r13!,{r4-r7,lr}
	SWI	XPDriver_Info
	MOVVS	r0,#0
	MOVVC	r0,r3
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	AREA	|____print_pagesize|, CODE, READONLY
	EXPORT	print_pagesize
print_pagesize

	STMFD	r13!,{r4-r6,lr}
	SWI	XPDriver_PageSize
	STMIA	r0,{r1-r6}
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____print_selectjob|, CODE, READONLY
	EXPORT	print_selectjob
print_selectjob

	SWI	XPDriver_SelectJob
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____print_currentjob|, CODE, READONLY
	EXPORT	print_currentjob
print_currentjob

	SWI	XPDriver_CurrentJob
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____print_endjob|, CODE, READONLY
	EXPORT	print_endjob
print_endjob

	SWI	XPDriver_EndJob
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____print_abortjob|, CODE, READONLY
	EXPORT	print_abortjob
print_abortjob

	STMFD	r13!,{r4-r12,lr}
	SWI	XPDriver_AbortJob
 [ arm32
	LDMFD	r13!,{r4-r12,pc}
 |
	LDMFD	r13!,{r4-r12,pc}^
 ]

	AREA	|____print_canceljob|, CODE, READONLY
	EXPORT	print_canceljob
print_canceljob

	SWI	XPDriver_CancelJob
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____print_canceljobwitherror|, CODE, READONLY
	EXPORT	print_canceljobwitherror
print_canceljobwitherror

	SWI	XPDriver_CancelJobWithError
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____print_declarefont|, CODE, READONLY
	EXPORT	print_declarefont
print_declarefont

	SWI	XPDriver_DeclareFont
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____print_giverectangle|, CODE, READONLY
	EXPORT	print_giverectangle
print_giverectangle

	MOV	r12,r4
	LDR	r4,[r13]
	SWI	XPDriver_GiveRectangle
	MOV	r4,r12
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____print_print|, CODE, READONLY
	EXPORT	print_print
print_print

	IMPORT	|__draw_localx|

; r0 is #copies
; r1 is #page
; r2 is ^ page string
; r3 is ^ routine
	STMFD	r13!,{r4,lr}
	LDR	lr,=print_inprint
	MOV	r4,#1
	STR	r4,[lr]
	MOV	r4,#0
	STR	r4,[lr,#4]
	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,r1
	LDR	r1,=print_rectangle
	SWI	XPDriver_DrawPage
	BVS	exit_printVS
print_printloop
	TEQ	r0,#0
	BEQ	exit_print
	MOV	r0,r2
	LDR	r2,=|__draw_localx|
	MOV	r3,#0
	STR	r3,[r2]
	STR	r3,[r2,#4]
	TEQ	r4,#0
	MOVNE	lr,pc
	MOVNE	pc,r4
	LDR	r1,=print_rectangle
	SWI	XPDriver_GetRectangle
	BVC	print_printloop

exit_printVS
	LDR	lr,=print_error
	STR	r0,[lr]
exit_print
	MOV	r0,#0
	LDR	lr,=print_inprint
	STR	r0,[lr]
	LDR	r0,[lr,#4]
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	print_rectangle, NOINIT
	%	16

	AREA	|____print_openfile|, CODE, READONLY
	EXPORT	print_openfile
print_openfile

	MOV	r1,r0
	MOV	r0,#128
	SWI	XOS_Find
	MOVVS	r0,#0
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____print_closefile|, CODE, READONLY
	EXPORT	print_closefile
print_closefile

	MOV	r1,r0
	MOV	r0,#0
	SWI	XOS_Find
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____print_inprint|, NOINIT
	EXPORT	print_inprint
print_inprint

	%	4
print_error
	%	4

	END
